'
' Hersey Vector Font Object
' by Vincent DeCampo
'
' This library is released under the LGPL
'
#Print "GxHVFont ENABLED"

Namespace GAMEX_GxHVFont
   
Type HVFVertex
   As Integer x,y,up
End Type

Type HVFChar
   As Integer      charID
   As Integer      vertcount
   As HVFVertex Ptr vert   
   As Integer      dx,dy
   As Integer      pre,post   
End Type

Type HVFCharSet
   As Integer     charCount
   As HVFChar Ptr chars
End Type

Enum GxHVFontS
   SCRIPTS 
   SCRIPTC 
   ROMANT  
   ROMANS   
   ROMANP   
   ROMANC   
   ROMANCS 
   ITALICT 
   ITALICC 
   GREEKS   
   GREEKP   
   GOTHGBT 
End Enum

Type GxHVFont
   
   Declare Constructor()
   Declare Constructor(font As GxHVFontS)
   Declare Destructor()

Public:   
   
   Declare Function LibVersion() As String
   
   Declare Function DrawString(  surface  As Any Ptr  = 0         , _
                                 x        As Integer              , _
                                 y        As Integer              , _
                                 text     As String               , _
                                 clr      As UInteger = &hFFFFFF  , _
                                 size     As Single   = 1 ) As Integer
   
   Declare Function GetFontHeight(size  As Single=1)                 As Integer
   Declare Function GetFontWidth (size  As Single=1)                 As Integer
   Declare Function GetCharWidth (ascii As UByte, size As Single=1)  As Integer
   Declare Function GetCharHeight(ascii As UByte, size As Single=1)  As Integer
   Declare Function SetFont      (font  As GxHVFontS)                  As Integer
   Declare Function GetHersheyID (ascii As UByte)                    As Integer
   Declare Function GetTextWidth (text  As String)                   As Integer
   
Private:
   
   Declare Function ReadFontData    () As Integer
   Declare Function DrawChar        (surface As Any Ptr=0, char As Integer) As Integer
   Declare Function FindIndex       (char As Integer) As Integer
   Declare Function RenderChar      (surface As Any Ptr, char As Integer) As Integer
   Declare Function ReadHersheyMap  (font As GxHVFontS) As Integer
   Declare Function CalculateMetrics() As Integer
         
   As HVFCharSet   charset

   As Integer  curposx, curposy
   As Integer  charmap(256)
   As Integer  indxmap(4096)
   
   As UInteger fontclr   
   As Single   fontsize
   As Integer  fontheight, fontwidth 'maximums
      
End Type

#Ifdef MAKELIB
   #Include "GxHVFont.bas"
#EndIf

End Namespace

#Ifdef MAKELIB
   #Include "HVFontdata.bas"
#EndIf

Using GAMEX_GxHVFont